// unsigned long BaseAddrs = 0xC000;
#define BaseAddrs               0xC000

/******************************************************************************\
* Master Board Addresses                                                       *
\******************************************************************************/
#define MSTR_BD_CTRL           (BaseAddrs + 0x0008)

#define CHAN_0_CTRL            (BaseAddrs + 0x0010)
#define CHAN_1_CTRL            (BaseAddrs + 0x0012)
#define CHAN_2_CTRL            (BaseAddrs + 0x0014)
#define CHAN_3_CTRL            (BaseAddrs + 0x0016)

#define CHAN_0_FIFO            (BaseAddrs + 0x0018)
#define CHAN_1_FIFO            (BaseAddrs + 0x001A)
#define CHAN_2_FIFO            (BaseAddrs + 0x001C)
#define CHAN_3_FIFO            (BaseAddrs + 0x001E)

#define CHAN_0_FIFOSTAT        (BaseAddrs + 0x0020)
#define CHAN_1_FIFOSTAT        (BaseAddrs + 0x0022)
#define CHAN_2_FIFOSTAT        (BaseAddrs + 0x0024)
#define CHAN_3_FIFOSTAT        (BaseAddrs + 0x0026)

#define CHAN_0_MASTER_SYNC     (BaseAddrs + 0x0028)
#define CHAN_1_MASTER_SYNC     (BaseAddrs + 0x002A)
#define CHAN_2_MASTER_SYNC     (BaseAddrs + 0x002C)
#define CHAN_3_MASTER_SYNC     (BaseAddrs + 0x002E)

#define MASTER_ICR             (BaseAddrs + 0x0030)
#define MASTER_ISR             (BaseAddrs + 0x0032)
#define MASTER_IVR             (BaseAddrs + 0x0034)

/******************************************************************************\
* Offsets of the 4 channels                                                    *
\******************************************************************************/

//unsigned int Generic_Zilog_Offset = 0x0200; // Default to CH0_ZILOG_OFFSET
#define Generic_Zilog_Offset    0x0200 // Default to CH0_ZILOG_OFFSET

#define CH0_ZILOG_OFFSET        0x0200
#define CH1_ZILOG_OFFSET        0x0280
#define CH2_ZILOG_OFFSET        0x0300
#define CH3_ZILOG_OFFSET        0x0380

/******************************************************************************\
* Offsets of registers internal to the Zilog z16c30                            *
\******************************************************************************/

#define CCARL_OFFSET          0x0000
#define CCARH_OFFSET          0x0002
#define CCSRH_OFFSET          0x000A
#define CCRH_OFFSET           0x000E
#define CMCRL_OFFSET          0x0020
#define CMCRH_OFFSET          0x0022
#define HCRL_OFFSET           0x0024
#define IVRL_OFFSET           0x0028
#define IOCRH_OFFSET          0x002E
#define ICRL_OFFSET           0x0030
#define ICRH_OFFSET           0x0032
#define DCCRH_OFFSET          0x0034
#define TXRXDTA_OFFSET        0x0040
#define RMRL_OFFSET           0x0044
#define RCSRL_OFFSET          0x0048
#define RCSRH_OFFSET          0x004A
#define RICRH_OFFSET          0x004E
#define TMRL_OFFSET           0x0064
#define TCSRL_OFFSET          0x0068
#define TCSRH_OFFSET          0x006A
#define TICRL_OFFSET          0x006C
#define TICRH_OFFSET          0x006E
#define TCCRL_OFFSET          0x0078

#define GENERIC_CCARL        (BaseAddrs + Generic_Zilog_Offset + CCARL_OFFSET   )
#define GENERIC_CCARH        (BaseAddrs + Generic_Zilog_Offset + CCARH_OFFSET   )
#define GENERIC_CCSRH        (BaseAddrs + Generic_Zilog_Offset + CCSRH_OFFSET   )
#define GENERIC_CCRH         (BaseAddrs + Generic_Zilog_Offset + CCRH_OFFSET    )
#define GENERIC_CMCRL        (BaseAddrs + Generic_Zilog_Offset + CMCRL_OFFSET   )
#define GENERIC_CMCRH        (BaseAddrs + Generic_Zilog_Offset + CMCRH_OFFSET   )
#define GENERIC_HCRL         (BaseAddrs + Generic_Zilog_Offset + HCRL_OFFSET    )
#define GENERIC_IVRL         (BaseAddrs + Generic_Zilog_Offset + IVRL_OFFSET    )
#define GENERIC_IOCRH        (BaseAddrs + Generic_Zilog_Offset + IOCRH_OFFSET   )
#define GENERIC_ICRL         (BaseAddrs + Generic_Zilog_Offset + ICRL_OFFSET    )
#define GENERIC_ICRH         (BaseAddrs + Generic_Zilog_Offset + ICRH_OFFSET    )
#define GENERIC_DCCRH        (BaseAddrs + Generic_Zilog_Offset + DCCRH_OFFSET   )
#define GENERIC_TXRXDTA      (BaseAddrs + Generic_Zilog_Offset + TXRXDTA_OFFSET )
#define GENERIC_RMRL         (BaseAddrs + Generic_Zilog_Offset + RMRL_OFFSET    )
#define GENERIC_RCSRL        (BaseAddrs + Generic_Zilog_Offset + RCSRL_OFFSET   )
#define GENERIC_RCSRH        (BaseAddrs + Generic_Zilog_Offset + RCSRH_OFFSET   )
#define GENERIC_RICRH        (BaseAddrs + Generic_Zilog_Offset + RICRH_OFFSET   )
#define GENERIC_TMRL         (BaseAddrs + Generic_Zilog_Offset + TMRL_OFFSET    )
#define GENERIC_TCSRL        (BaseAddrs + Generic_Zilog_Offset + TCSRL_OFFSET   )
#define GENERIC_TCSRH        (BaseAddrs + Generic_Zilog_Offset + TCSRH_OFFSET   )
#define GENERIC_TICRL        (BaseAddrs + Generic_Zilog_Offset + TICRL_OFFSET   )
#define GENERIC_TICRH        (BaseAddrs + Generic_Zilog_Offset + TICRH_OFFSET   )
#define GENERIC_TCCRL        (BaseAddrs + Generic_Zilog_Offset + TCCRL_OFFSET   )

#define Chan0_CCARL          (BaseAddrs + CH0_ZILOG_OFFSET + CCARL_OFFSET   )
#define Chan0_CCARH          (BaseAddrs + CH0_ZILOG_OFFSET + CCARH_OFFSET   )
#define Chan0_CCSRH          (BaseAddrs + CH0_ZILOG_OFFSET + CCSRH_OFFSET   )
#define Chan0_CCRH           (BaseAddrs + CH0_ZILOG_OFFSET + CCRH_OFFSET    )
#define Chan0_CMCRL          (BaseAddrs + CH0_ZILOG_OFFSET + CMCRL_OFFSET   )
#define Chan0_CMCRH          (BaseAddrs + CH0_ZILOG_OFFSET + CMCRH_OFFSET   )
#define Chan0_HCRL           (BaseAddrs + CH0_ZILOG_OFFSET + HCRL_OFFSET    )
#define Chan0_IVRL           (BaseAddrs + CH0_ZILOG_OFFSET + IVRL_OFFSET    )
#define Chan0_IOCRH          (BaseAddrs + CH0_ZILOG_OFFSET + IOCRH_OFFSET   )
#define Chan0_ICRL           (BaseAddrs + CH0_ZILOG_OFFSET + ICRL_OFFSET    )
#define Chan0_ICRH           (BaseAddrs + CH0_ZILOG_OFFSET + ICRH_OFFSET    )
#define Chan0_DCCRH          (BaseAddrs + CH0_ZILOG_OFFSET + DCCRH_OFFSET   )
#define Chan0_TXRXDTA        (BaseAddrs + CH0_ZILOG_OFFSET + TXRXDTA_OFFSET )
#define Chan0_RMRL           (BaseAddrs + CH0_ZILOG_OFFSET + RMRL_OFFSET    )
#define Chan0_RCSRL          (BaseAddrs + CH0_ZILOG_OFFSET + RCSRL_OFFSET   )
#define Chan0_RCSRH          (BaseAddrs + CH0_ZILOG_OFFSET + RCSRH_OFFSET   )
#define Chan0_RICRH          (BaseAddrs + CH0_ZILOG_OFFSET + RICRH_OFFSET   )
#define Chan0_TMRL           (BaseAddrs + CH0_ZILOG_OFFSET + TMRL_OFFSET    )
#define Chan0_TCSRL          (BaseAddrs + CH0_ZILOG_OFFSET + TCSRL_OFFSET   )
#define Chan0_TCSRH          (BaseAddrs + CH0_ZILOG_OFFSET + TCSRH_OFFSET   )
#define Chan0_TICRL          (BaseAddrs + CH0_ZILOG_OFFSET + TICRL_OFFSET   )
#define Chan0_TICRH          (BaseAddrs + CH0_ZILOG_OFFSET + TICRH_OFFSET   )
#define Chan0_TCCRL          (BaseAddrs + CH0_ZILOG_OFFSET + TCCRL_OFFSET   )

#define Chan1_CCARL          (BaseAddrs + CH1_ZILOG_OFFSET + CCARL_OFFSET   )
#define Chan1_CCARH          (BaseAddrs + CH1_ZILOG_OFFSET + CCARH_OFFSET   )
#define Chan1_CCSRH          (BaseAddrs + CH1_ZILOG_OFFSET + CCSRH_OFFSET   )
#define Chan1_CCRH           (BaseAddrs + CH1_ZILOG_OFFSET + CCRH_OFFSET    )
#define Chan1_CMCRL          (BaseAddrs + CH1_ZILOG_OFFSET + CMCRL_OFFSET   )
#define Chan1_CMCRH          (BaseAddrs + CH1_ZILOG_OFFSET + CMCRH_OFFSET   )
#define Chan1_HCRL           (BaseAddrs + CH1_ZILOG_OFFSET + HCRL_OFFSET    )
#define Chan1_IVRL           (BaseAddrs + CH1_ZILOG_OFFSET + IVRL_OFFSET    )
#define Chan1_IOCRH          (BaseAddrs + CH1_ZILOG_OFFSET + IOCRH_OFFSET   )
#define Chan1_ICRL           (BaseAddrs + CH1_ZILOG_OFFSET + ICRL_OFFSET    )
#define Chan1_ICRH           (BaseAddrs + CH1_ZILOG_OFFSET + ICRH_OFFSET    )
#define Chan1_DCCRH          (BaseAddrs + CH1_ZILOG_OFFSET + DCCRH_OFFSET   )
#define Chan1_TXRXDTA        (BaseAddrs + CH1_ZILOG_OFFSET + TXRXDTA_OFFSET )
#define Chan1_RMRL           (BaseAddrs + CH1_ZILOG_OFFSET + RMRL_OFFSET    )
#define Chan1_RCSRL          (BaseAddrs + CH1_ZILOG_OFFSET + RCSRL_OFFSET   )
#define Chan1_RCSRH          (BaseAddrs + CH1_ZILOG_OFFSET + RCSRH_OFFSET   )
#define Chan1_RICRH          (BaseAddrs + CH1_ZILOG_OFFSET + RICRH_OFFSET   )
#define Chan1_TMRL           (BaseAddrs + CH1_ZILOG_OFFSET + TMRL_OFFSET    )
#define Chan1_TCSRL          (BaseAddrs + CH1_ZILOG_OFFSET + TCSRL_OFFSET   )
#define Chan1_TCSRH          (BaseAddrs + CH1_ZILOG_OFFSET + TCSRH_OFFSET   )
#define Chan1_TICRL          (BaseAddrs + CH1_ZILOG_OFFSET + TICRL_OFFSET   )
#define Chan1_TICRH          (BaseAddrs + CH1_ZILOG_OFFSET + TICRH_OFFSET   )
#define Chan1_TCCRL          (BaseAddrs + CH1_ZILOG_OFFSET + TCCRL_OFFSET   )

#define Chan2_CCARL          (BaseAddrs + CH2_ZILOG_OFFSET + CCARL_OFFSET   )
#define Chan2_CCARH          (BaseAddrs + CH2_ZILOG_OFFSET + CCARH_OFFSET   )
#define Chan2_CCSRH          (BaseAddrs + CH2_ZILOG_OFFSET + CCSRH_OFFSET   )
#define Chan2_CCRH           (BaseAddrs + CH2_ZILOG_OFFSET + CCRH_OFFSET    )
#define Chan2_CMCRL          (BaseAddrs + CH2_ZILOG_OFFSET + CMCRL_OFFSET   )
#define Chan2_CMCRH          (BaseAddrs + CH2_ZILOG_OFFSET + CMCRH_OFFSET   )
#define Chan2_HCRL           (BaseAddrs + CH2_ZILOG_OFFSET + HCRL_OFFSET    )
#define Chan2_IVRL           (BaseAddrs + CH2_ZILOG_OFFSET + IVRL_OFFSET    )
#define Chan2_IOCRH          (BaseAddrs + CH2_ZILOG_OFFSET + IOCRH_OFFSET   )
#define Chan2_ICRL           (BaseAddrs + CH2_ZILOG_OFFSET + ICRL_OFFSET    )
#define Chan2_ICRH           (BaseAddrs + CH2_ZILOG_OFFSET + ICRH_OFFSET    )
#define Chan2_DCCRH          (BaseAddrs + CH2_ZILOG_OFFSET + DCCRH_OFFSET   )
#define Chan2_TXRXDTA        (BaseAddrs + CH2_ZILOG_OFFSET + TXRXDTA_OFFSET )
#define Chan2_RMRL           (BaseAddrs + CH2_ZILOG_OFFSET + RMRL_OFFSET    )
#define Chan2_RCSRL          (BaseAddrs + CH2_ZILOG_OFFSET + RCSRL_OFFSET   )
#define Chan2_RCSRH          (BaseAddrs + CH2_ZILOG_OFFSET + RCSRH_OFFSET   )
#define Chan2_RICRH          (BaseAddrs + CH2_ZILOG_OFFSET + RICRH_OFFSET   )
#define Chan2_TMRL           (BaseAddrs + CH2_ZILOG_OFFSET + TMRL_OFFSET    )
#define Chan2_TCSRL          (BaseAddrs + CH2_ZILOG_OFFSET + TCSRL_OFFSET   )
#define Chan2_TCSRH          (BaseAddrs + CH2_ZILOG_OFFSET + TCSRH_OFFSET   )
#define Chan2_TICRL          (BaseAddrs + CH2_ZILOG_OFFSET + TICRL_OFFSET   )
#define Chan2_TICRH          (BaseAddrs + CH2_ZILOG_OFFSET + TICRH_OFFSET   )
#define Chan2_TCCRL          (BaseAddrs + CH2_ZILOG_OFFSET + TCCRL_OFFSET   )

#define Chan3_CCARL          (BaseAddrs + CH3_ZILOG_OFFSET + CCARL_OFFSET   )
#define Chan3_CCARH          (BaseAddrs + CH3_ZILOG_OFFSET + CCARH_OFFSET   )
#define Chan3_CCSRH          (BaseAddrs + CH3_ZILOG_OFFSET + CCSRH_OFFSET   )
#define Chan3_CCRH           (BaseAddrs + CH3_ZILOG_OFFSET + CCRH_OFFSET    )
#define Chan3_CMCRL          (BaseAddrs + CH3_ZILOG_OFFSET + CMCRL_OFFSET   )
#define Chan3_CMCRH          (BaseAddrs + CH3_ZILOG_OFFSET + CMCRH_OFFSET   )
#define Chan3_HCRL           (BaseAddrs + CH3_ZILOG_OFFSET + HCRL_OFFSET    )
#define Chan3_IVRL           (BaseAddrs + CH3_ZILOG_OFFSET + IVRL_OFFSET    )
#define Chan3_IOCRH          (BaseAddrs + CH3_ZILOG_OFFSET + IOCRH_OFFSET   )
#define Chan3_ICRL           (BaseAddrs + CH3_ZILOG_OFFSET + ICRL_OFFSET    )
#define Chan3_ICRH           (BaseAddrs + CH3_ZILOG_OFFSET + ICRH_OFFSET    )
#define Chan3_DCCRH          (BaseAddrs + CH3_ZILOG_OFFSET + DCCRH_OFFSET   )
#define Chan3_TXRXDTA        (BaseAddrs + CH3_ZILOG_OFFSET + TXRXDTA_OFFSET )
#define Chan3_RMRL           (BaseAddrs + CH3_ZILOG_OFFSET + RMRL_OFFSET    )
#define Chan3_RCSRL          (BaseAddrs + CH3_ZILOG_OFFSET + RCSRL_OFFSET   )
#define Chan3_RCSRH          (BaseAddrs + CH3_ZILOG_OFFSET + RCSRH_OFFSET   )
#define Chan3_RICRH          (BaseAddrs + CH3_ZILOG_OFFSET + RICRH_OFFSET   )
#define Chan3_TMRL           (BaseAddrs + CH3_ZILOG_OFFSET + TMRL_OFFSET    )
#define Chan3_TCSRL          (BaseAddrs + CH3_ZILOG_OFFSET + TCSRL_OFFSET   )
#define Chan3_TCSRH          (BaseAddrs + CH3_ZILOG_OFFSET + TCSRH_OFFSET   )
#define Chan3_TICRL          (BaseAddrs + CH3_ZILOG_OFFSET + TICRL_OFFSET   )
#define Chan3_TICRH          (BaseAddrs + CH3_ZILOG_OFFSET + TICRH_OFFSET   )
#define Chan3_TCCRL          (BaseAddrs + CH3_ZILOG_OFFSET + TCCRL_OFFSET   )
