/*
 * Copyright 1994 by RadiSys Corporation.  All rights reserved.
 */

/*
 * busmgr.h -- EPConnect standard header file.
 *
 * $Header:   S:/src/include/busmgr.h_v   1.51   06 Apr 1994 17:14:46   bprochaska  $
 * $Locker$
 */

/*$MK+SKIP*/
#ifndef _FENCE_BUSMGR_H_
#define _FENCE_BUSMGR_H_

#if (defined(__TCPLUSPLUS__) || defined(__BCPLUSPLUS__) || defined(__cplusplus))
extern "C" {
#endif /* __TCPLUSPLUS__ or __BCPLUSPLUS__ or __cplusplus */
/*$MK-SKIP*/

/*
 * For EPConnect/VXI, VXI is defined automatically.  Otherwise, make sure VME
 * is defined.
 */

/* __AUTOMAGIC_HERE__ */

#ifndef VXI
#define VME
#endif  /* not VXI */

#ifdef LynxOS
#ifdef SWENG
#include "c:\epconnec\include\epcstd.h"
#else  /* not SWENG */
#include <c:\epconnec\include\epcstd.h>
#endif /* not SWENG */
#else  /* not LynxOS */
#include "c:\epconnec\include\epc_obm.h"
#include "c:\epconnec\include\epcstd.h"
#endif /* not LynxOS */

/*$MK+SKIP*/
#ifdef LynxOS
#ifdef HUGE
#define __LYNXOS_HUGE__ HUGE
#undef HUGE
#endif /* HUGE */
#define HUGE
#endif /* LynxOS */
/*$MK-SKIP*/

/*
 * CONSTANTS...
 */

/*
 * Error constants.
 */

#define EPC_SUCCESS             ((short) 0x0000)
                                        /* Successful function completion.   */
#define EPC_BERR                ((short) 0x0001)
                                        /* BERR occurred.                    */
#define EPC_DIR_ERR             ((short) 0x0002)
                                        /* DIR WS protocol error occurred.   */
#define EPC_DOR_ERR             ((short) 0x0003)
                                        /* DOR WS protocol error occurred.   */
#define EPC_INV_ADDMOD          ((short) 0x0004)
                                        /* Invalid VMEbus address modifier.  */
#define EPC_INV_ALIGN           ((short) 0x0005)
                                        /* Invalid bus address alignment.    */
#define EPC_INV_ARB_MODE        ((short) 0x0006)
                                        /* Invalid bus arbitration mode.     */
#define EPC_INV_ARB_PRIORITY    ((short) 0x0007)
                                        /* Invalid bus arbitration priority. */
#define EPC_INV_ASSERT          ((short) 0x0008)
                                        /* Invalid VMEbus interrupt assert.  */
#define EPC_INV_ATTR            ((short) 0x0009)
                                        /* Invalid arbitrary attribute.      */
#define EPC_INV_BASE            ((short) 0x000A)
                                        /* Invalid slave memory base address.*/
#define EPC_INV_BORDER          ((short) 0x000B)
                                        /* Invalid byte ordering.            */
#define EPC_INV_CFG             ((short) 0x000C)
                                        /* Invalid watchdog timer cfg.       */
#define EPC_INV_ENABLE          ((short) 0x000D)
                                        /* Invalid bus enable parameter.     */
#define EPC_INV_ERROR           ((short) 0x000E)
                                        /* Invalid protocol error.           */
#define EPC_INV_EVENT           ((short) 0x000F)
                                        /* Invalid protocol event.           */
#define EPC_INV_GPA             ((short) 0x0010)
                                        /* Invalid GPIB address.             */
#define EPC_INV_HW              ((short) 0x0011)
                                        /* Invalid (unsupported) hardware.   */
#define EPC_INV_MAP             ((short) 0x0012)
                                        /* Invalid bus mapping.              */
#define EPC_INV_MASK            ((short) 0x0013)
                                        /* Invalid mask parameter.           */
#define EPC_INV_METHOD          ((short) 0x0014)
                                        /* Invalid protocol event method.    */
#define EPC_INV_NAME            ((short) 0x0015)
                                        /* Invalid device name.              */
#define EPC_INV_PTR             ((short) 0x0016)
                                        /* Invalid pointer parameter.        */
#define EPC_INV_RANGE           ((short) 0x0017)
                                        /* Invalid address range.            */
#define EPC_INV_RELEASE         ((short) 0x0018)
                                        /* Invalid bus release mode.         */
#define EPC_INV_SESSION         ((short) 0x0019)
                                        /* Invalid session handle.           */
#define EPC_INV_SIZE            ((short) 0x001A)
                                        /* Invalid size parameter.           */
#define EPC_INV_SPACE           ((short) 0x001B)
                                        /* Invalid slave memory addr. space. */
#define EPC_INV_SW              ((short) 0x001C)
                                        /* Invalid (missing) software.       */
#define EPC_INV_SWAP            ((short) 0x001D)
                                        /* Invalid byte swapping operation.  */
#define EPC_INV_TERMCHR         ((short) 0x001E)
                                        /* Invalid termination character.    */
#define EPC_INV_ULA             ((short) 0x001F)
                                        /* Invalid unique logical address.   */
#define EPC_INV_USAGE           ((short) 0x0020)
                                        /* Invalid unique logical address.   */
#define EPC_INV_WIDTH           ((short) 0x0021)
                                        /* Invalid data width.               */
#define EPC_LOCKED              ((short) 0x0022)
                                        /* The shared EPC hardware is locked */
                                        /* by another session.               */
#define EPC_MULTIPLE_ERR        ((short) 0x0023)
                                        /* A multiple queries WS protocol    */
                                        /* error has occurred.               */
#define EPC_NOT_LOCKED          ((short) 0x0024)
                                        /* The session has not locked the    */
                                        /* shared EPC hardware.              */
#define EPC_NO_DATA             ((short) 0x0025)
                                        /* The resource manager database     */
                                        /* not contain the requested data.   */
#define EPC_NO_DEVICE           ((short) 0x0026)
                                        /* The resource manager database     */
                                        /* does not contain a device with    */
                                        /* the specified address.            */
#define EPC_OS_ERROR            ((short) 0x0027)
                                        /* An operating system specific      */
                                        /* error occurred.                   */
#define EPC_OUT_OF_RSRCS        ((short) 0x0028)
                                        /* Out of resources.                 */
#define EPC_RECV_BERR           ((short) 0x0029)
                                        /* BERR during WS reception.         */
#define EPC_RECV_CLEAR          ((short) 0x002A)
                                        /* CLEAR WS command received while   */
                                        /* waiting for READ PROTOCOL ERROR   */
                                        /* WS command.                       */
#define EPC_RECV_TIMEOUT        ((short) 0x002B)
                                        /* Timeout during WS reception.      */
#define EPC_SEND_BERR           ((short) 0x002C)
                                        /* BERR during WS send.              */
#define EPC_SEND_TIMEOUT        ((short) 0x002D)
                                        /* Timeout during WS send.           */
#define EPC_TIMEOUT             ((short) 0x002E)
                                        /* A timeout occurred.               */
#define EPC_WS_PROTOCOL         ((short) 0x002F)
                                        /* A WS protocol error occurred.     */

#define EPC_ABORT		((short) 0x0030)
                                        /* Operation aborted.                */
#define EPC_RECV_ANO		((short) 0x0031)
                                        /* ABORT NORMAL OPERATION WS command */
                                        /* received while waiting for READ   */
                                        /* PROTOCOL ERROR WS command.        */
#define EPC_RECV_ENO		((short) 0x0032)
                                        /* END NORMAL OPERATION WS command   */
                                        /* received while waiting for READ   */
                                        /* PROTOCOL ERROR WS command.        */

#define EPC_MAX_ERROR           EPC_RECV_ENO
					/* Maximum valid EPConnect return    */
                                        /* value.                            */

/*
 * Size constants.
 */

#define ERROR_STRING_SZ         ((short) 32)
                                        /* Maximum error string size, in     */
                                        /* bytes.                            */

/*
 * EPC type contants.
 */

#define EPC_1                   ((unsigned char) 0x01)
                                        /* EPC-1.                            */
#define EPC_2                   ((unsigned char) 0x02)
                                        /* EPC-2.                            */
#define EPC_3                   ((unsigned char) 0x03)
                                        /* EPC-3.                            */
#define EPC_2X                  ((unsigned char) 0x04)
                                        /* EPC-2X.                            */
#define EPC_4                   ((unsigned char) 0x05)
                                        /* EPC-4.                            */
#define EPC_5                   ((unsigned char) 0x06)
                                        /* EPC-5.                            */
#define EPC_6                   ((unsigned char) 0x07)
                                        /* EPC-6.                            */
#define EPC_7                   ((unsigned char) 0x08)
                                        /* EPC-7.                            */

/*
 * Address modifier constants.
 */

#define EPC_A16S                ((unsigned short) 0x0001)
                                        /* A16 supervisory.                  */
#define EPC_A24SD               ((unsigned short) 0x0002)
                                        /* A24 supervisory data.             */
#define EPC_A32SD               ((unsigned short) 0x0004)
                                        /* A32 supervisory data.             */
#define EPC_SHARED              ((unsigned short) 0x8000)
                                        /* EPC shared memory.                */

/*
 * Byte ordering constants.
 */

#define EPC_IBO                 ((unsigned short) 0x0001)
                                        /* Intel (little-endian) byte order. */
#define EPC_MBO                 ((unsigned short) 0x0002)
                                        /* Motorola (big-endian) byte order. */

/*
 * Data width constants.
 */

#define EPC_8_BIT               ((unsigned short) 0x0001)
                                        /* 8-bit data width.                 */
#define EPC_8_BIT_ODD           ((unsigned short) 0x0002)
                                        /* 8-bit data width (odd only).      */
#define EPC_16_BIT              ((unsigned short) 0x0004)
                                        /* 16-bit data width.                */
#define EPC_32_BIT              ((unsigned short) 0x0008)
                                        /* 32-bit data width.                */
#define EPC_48_BIT              ((unsigned short) 0x0010)
                                        /* 48-bit data width.                */
#define EPC_64_BIT              ((unsigned short) 0x0020)
                                        /* 64-bit data width.                */
#define EPC_80_BIT              ((unsigned short) 0x0040)
                                        /* 80-bit data width.                */
#define EPC_FASTCOPY            ((unsigned short) 0x0080)
                                        /* Fast copy flag (skip BERR check). */
#define EPC_SELFACCESS          ((unsigned short) 0x0100)
                                        /* Self access flag.                 */

/*
 * Event constants.
 */

#define EPC_NO_INT              ((unsigned long) 0x00000000)
                                        /* Message interrupt event.          */
#define EPC_MSG_INT             ((unsigned long) 0x00000001)
                                        /* Message interrupt event.          */
#define EPC_VME1_INT            ((unsigned long) 0x00000002)
                                        /* VME interrupt 1 event.            */
#define EPC_VME2_INT            ((unsigned long) 0x00000004)
                                        /* VME interrupt 2 event.            */
#define EPC_VME3_INT            ((unsigned long) 0x00000008)
                                        /* VME interrupt 3 event.            */
#define EPC_VME4_INT            ((unsigned long) 0x00000010)
                                        /* VME interrupt 4 event.            */
#define EPC_VME5_INT            ((unsigned long) 0x00000020)
                                        /* VME interrupt 5 event.            */
#define EPC_VME6_INT            ((unsigned long) 0x00000040)
                                        /* VME interrupt 6 event.            */
#define EPC_VME7_INT            ((unsigned long) 0x00000080)
                                        /* VME interrupt 7 event.            */
#define EPC_TTL_TRIG0_INT       ((unsigned long) 0x00000100)
                                        /* TTL trigger 0 interrupt event.    */
#define EPC_TTL_TRIG1_INT       ((unsigned long) 0x00000200)
                                        /* TTL trigger 1 interrupt event.    */
#define EPC_TTL_TRIG2_INT       ((unsigned long) 0x00000400)
                                        /* TTL trigger 2 interrupt event.    */
#define EPC_TTL_TRIG3_INT       ((unsigned long) 0x00000800)
                                        /* TTL trigger 3 interrupt event.    */
#define EPC_TTL_TRIG4_INT       ((unsigned long) 0x00001000)
                                        /* TTL trigger 4 interrupt event.    */
#define EPC_TTL_TRIG5_INT       ((unsigned long) 0x00002000)
                                        /* TTL trigger 5 interrupt event.    */
#define EPC_TTL_TRIG6_INT       ((unsigned long) 0x00004000)
                                        /* TTL trigger 6 interrupt event.    */
#define EPC_TTL_TRIG7_INT       ((unsigned long) 0x00008000)
                                        /* TTL trigger 7 interrupt event.    */
#define EPC_SYSFAIL_ERR         ((unsigned long) 0x00010000)
                                        /* SYSFAIL error event.              */
#define EPC_BERR_ERR            ((unsigned long) 0x00020000)
                                        /* BERR error event.                 */
#define EPC_ACFAIL_ERR          ((unsigned long) 0x00040000)
                                        /* ACFAIL error event.               */
#define EPC_WATCHDOG_ERR        ((unsigned long) 0x00080000)
                                        /* Watchdog timer error event.       */
#define EPC_SIGNAL_INT          ((unsigned long) 0x00100000)
                                        /* Signal FIFO interrupt event.      */
#define EPC_SYSRESET_ERR        ((unsigned long) 0x00200000)
                                        /* SYSRESET error event.             */

#ifdef VXI
#define EPC_EVENT_CNT           ((short) 22)
#else  /* not VXI */
#define EPC_EVENT_CNT           ((short) 13)
#endif /* not VXI */

/*
 * Bus enable constants.
 */

#define EPC_DISABLE_BUS         ((unsigned short) 0x0001)
                                        /* Bus disabled.                     */
#define EPC_ENABLE_BUS          ((unsigned short) 0x0002)
                                        /* Bus enabled.                      */

/*
 * Bus arbitration mode contants.
 */

#define EPC_PRIORITY            ((unsigned short) 0x0001)
                                        /* Priority bus arbitration.         */
#define EPC_ROUND_ROBIN         ((unsigned short) 0x0002)
                                        /* Round-robin bus arbitration.      */

/*
 * Bus arbitration priority contants.
 */

#define EPC_PRIORITY0           ((unsigned short) 0x0001)
                                        /* Priority 0 bus arbitration.       */
#define EPC_PRIORITY1           ((unsigned short) 0x0002)
                                        /* Priority 1 bus arbitration.       */
#define EPC_PRIORITY2           ((unsigned short) 0x0004)
                                        /* Priority 2 bus arbitration.       */
#define EPC_PRIORITY3           ((unsigned short) 0x0008)
                                        /* Priority 3 bus arbitration.       */

/*
 * Bus release mode constants.
 */

#define EPC_ROR                 ((unsigned short) 0x0001)
                                        /* "Release On Request".             */
#define EPC_RONR                ((unsigned short) 0x0002)
                                        /* "Release On No Request".          */

/*
 * Miscellaneous EPC attribute constants.
 */

#define EPC_DIR                 ((unsigned long) 0x00000001)
                                        /* DIR bit.                          */
#define EPC_DOR                 ((unsigned long) 0x00000002)
                                        /* DOR bit.                          */
#define EPC_ERR                 ((unsigned long) 0x00000004)
                                        /* ERR* bit.                         */
#define EPC_PASS                ((unsigned long) 0x00000008)
                                        /* PASSED bit.                       */
#define EPC_PIPELINE_BUSY       ((unsigned long) 0x00000010)
                                        /* Pipeline busy bit.                */
#define EPC_READY               ((unsigned long) 0x00000020)
                                        /* READY bit.                        */
#define EPC_RESET               ((unsigned long) 0x00000040)
                                        /* Reset the EPC.                    */
#define EPC_RRDY                ((unsigned long) 0x00000080)
                                        /* Read Ready bit.                   */
#define EPC_RSRC_MGR            ((unsigned long) 0x00000100)
                                        /* Resource Manager execution bit.   */
#define EPC_STICKY_BERR         ((unsigned long) 0x00000200)
                                        /* "Sticky" bus error bit.           */
#define EPC_SYSFAIL_OUT         ((unsigned long) 0x00000400)
                                        /* SYSFAIL output enable bit.        */
#define EPC_SYSRESET_IN         ((unsigned long) 0x00000800)
                                        /* SYSRESET input enable bit.        */
#define EPC_TTL_LATCH0          ((unsigned long) 0x00001000)
                                        /* TTL trigger 0 latch bit.          */
#define EPC_TTL_LATCH1          ((unsigned long) 0x00002000)
                                        /* TTL trigger 0 latch bit.          */
#define EPC_TTL_LATCH2          ((unsigned long) 0x00004000)
                                        /* TTL trigger 0 latch bit.          */
#define EPC_TTL_LATCH3          ((unsigned long) 0x00008000)
                                        /* TTL trigger 0 latch bit.          */
#define EPC_TTL_LATCH4          ((unsigned long) 0x00010000)
                                        /* TTL trigger 0 latch bit.          */
#define EPC_TTL_LATCH5          ((unsigned long) 0x00020000)
                                        /* TTL trigger 0 latch bit.          */
#define EPC_TTL_LATCH6          ((unsigned long) 0x00040000)
                                        /* TTL trigger 0 latch bit.          */
#define EPC_TTL_LATCH7          ((unsigned long) 0x00080000)
                                        /* TTL trigger 0 latch bit.          */
#define EPC_WATCHDOG            ((unsigned long) 0x00100000)
                                        /* Watchdog timer expiration bit.    */
#define EPC_WRDY                ((unsigned long) 0x00200000)
                                        /* Write Ready bit.                  */
#define EPC_LOCK		((unsigned long) 0x00400000)
                                        /* Locked* bit.                      */

/*
 * Slave memory address space constants.
 */

#define EPC_DISABLED            ((unsigned short) 0x0001)
                                        /* Slave memory disabled.            */
#define EPC_A24                 ((unsigned short) 0x0002)
                                        /* Slave memory A24 mapping.         */
#define EPC_A32                 ((unsigned short) 0x0004)
                                        /* Slave memory A32 mapping.         */

/*
 * EPC/bus control line constants.
 */

#define EPC_ACFAIL              ((unsigned long) 0x00000001)
                                        /* ACFAIL line.                      */
#define EPC_SYSFAIL             ((unsigned long) 0x00000002)
                                        /* SYSFAIL line.                     */
#define EPC_SYSRESET            ((unsigned long) 0x00000004)
                                        /* SYSRESET line.                    */

/*
 * EPC/bus MODID line constants.
 */

#define EPC_SLOT_MODID          ((unsigned long) 0x00000001)
                                        /* MODID line for EPC's bus slot.    */
#define EPC_MODID0              ((unsigned long) 0x00000002)
                                        /* MODID line 0.                     */
#define EPC_MODID1              ((unsigned long) 0x00000004)
                                        /* MODID line 1.                     */
#define EPC_MODID2              ((unsigned long) 0x00000008)
                                        /* MODID line 2.                     */
#define EPC_MODID3              ((unsigned long) 0x00000010)
                                        /* MODID line 3.                     */
#define EPC_MODID4              ((unsigned long) 0x00000020)
                                        /* MODID line 4.                     */
#define EPC_MODID5              ((unsigned long) 0x00000040)
                                        /* MODID line 5.                     */
#define EPC_MODID6              ((unsigned long) 0x00000080)
                                        /* MODID line 6.                     */
#define EPC_MODID7              ((unsigned long) 0x00000100)
                                        /* MODID line 7.                     */
#define EPC_MODID8              ((unsigned long) 0x00000200)
                                        /* MODID line 8.                     */
#define EPC_MODID9              ((unsigned long) 0x00000400)
                                        /* MODID line 9.                     */
#define EPC_MODID10             ((unsigned long) 0x00000800)
                                        /* MODID line 10.                    */
#define EPC_MODID11             ((unsigned long) 0x00001000)
                                        /* MODID line 11.                    */
#define EPC_MODID12             ((unsigned long) 0x00002000)
                                        /* MODID line 12.                    */

/*
 * EPC/bus trigger line constants.
 */

#define EPC_ECL_TRIG0           ((unsigned long) 0x00000001)
                                        /* ECL trigger line 0.               */
#define EPC_ECL_TRIG1           ((unsigned long) 0x00000002)
                                        /* ECL trigger line 1.               */
#define EPC_EXT_TRIG0           ((unsigned long) 0x00000100)
                                        /* EXT trigger line 0.               */
#define EPC_TTL_TRIG0           ((unsigned long) 0x00010000)
                                        /* TTL trigger line 0.               */
#define EPC_TTL_TRIG1           ((unsigned long) 0x00020000)
                                        /* TTL trigger line 1.               */
#define EPC_TTL_TRIG2           ((unsigned long) 0x00040000)
                                        /* TTL trigger line 2.               */
#define EPC_TTL_TRIG3           ((unsigned long) 0x00080000)
                                        /* TTL trigger line 3.               */
#define EPC_TTL_TRIG4           ((unsigned long) 0x00100000)
                                        /* TTL trigger line 4.               */
#define EPC_TTL_TRIG5           ((unsigned long) 0x00200000)
                                        /* TTL trigger line 5.               */
#define EPC_TTL_TRIG6           ((unsigned long) 0x00400000)
                                        /* TTL trigger line 6.               */
#define EPC_TTL_TRIG7           ((unsigned long) 0x00800000)
                                        /* TTL trigger line 7.               */

/*
 * EPC/bus trigger line array constants.
 */

#define EPC_ECL_TRIG0_NUM       ((short)  0)
#define EPC_ECL_TRIG1_NUM       ((short)  1)
#define EPC_EXT_TRIG0_NUM       ((short)  8)
#define EPC_TTL_TRIG0_NUM       ((short) 16)
#define EPC_TTL_TRIG1_NUM       ((short) 17)
#define EPC_TTL_TRIG2_NUM       ((short) 18)
#define EPC_TTL_TRIG3_NUM       ((short) 19)
#define EPC_TTL_TRIG4_NUM       ((short) 20)
#define EPC_TTL_TRIG5_NUM       ((short) 21)
#define EPC_TTL_TRIG6_NUM       ((short) 22)
#define EPC_TTL_TRIG7_NUM       ((short) 23)

#define EPC_TRIGGER_CNT         ((short) 24)

/*
 * Watchdog timer configuration constants.
 */

#define EPC_WDT_RESET           ((unsigned short) 0x0001)
                                        /* Reset timer.                      */
#define EPC_WDT_FAST_ERROR      ((unsigned short) 0x0002)
                                        /* Reset timer; short period; error. */
#define EPC_WDT_FAST_RESET      ((unsigned short) 0x0004)
                                        /* Reset timer; short period; reset. */
#define EPC_WDT_SLOW_ERROR      ((unsigned short) 0x0008)
                                        /* Reset timer; long period; error.  */
#define EPC_WDT_SLOW_RESET      ((unsigned short) 0x0010)
                                        /* Reset timer; long period; reset.  */

/*
 * Commander device word serial receive buffer termination constants.
 */

#define EPC_TERM_CHAR           ((unsigned short) 0x0001)
                                        /* Termination character received.   */
#define EPC_TERM_EOI            ((unsigned short) 0x0002)
                                        /* END indicator received.           */
#define EPC_TERM_FULL           ((unsigned short) 0x0004)
                                        /* Buffer full.                      */

/*
 * Servant device word serial enable constants.
 */

#define EPC_DISABLE_ALL         ((unsigned short) 0x0001)
                                        /* Disable command reception.        */
#define EPC_ENABLE_WRDY         ((unsigned short) 0x0002)
                                        /* Enable command reception.         */
#define EPC_ENABLE_DIR          ((unsigned short) 0x0004)
                                        /* Enable data input.                */
#define EPC_ENABLE_DOR          ((unsigned short) 0x0008)
                                        /* Enable data output.               */
#define EPC_ENABLE_ALL          ((unsigned short) 0x0010)
                                        /* Enable all.                       */

/*
 * Protocol event transport method mask constants.
 *
 * NOTES:
 *     1.  The constants EPC_VME1_INT through EPC_VME7_INT are defined above.
 */

#define EPC_SIGNAL_REG          (EPC_SIGNAL_INT)
                                        /* Write to the commander device's   */
                                        /* signal register.                  */

/*$MK+SKIP*/

/*
 * STRUCTURES...
 */

#ifndef LynxOS
#pragma pack(1)
#endif /* LynxOS */

struct EpcEnvironment
{
    /* Hardware, firmware, and software revision attributes. */

    unsigned char  HWRevision;          /* Hardware revision number:         */
                                        /*     EPC_4                         */
                                        /*     EPC_5                         */
                                        /*     EPC_7                         */
    unsigned char  BIOSMajorRevision;   /* BIOS major revision number.       */
    unsigned char  BIOSMinorRevision;   /* BIOS minor revision number.       */
    unsigned char  SWMajorRevision;     /* Software major revision number.   */
    unsigned char  SWMinorRevision;     /* Software minor revision number.   */

    /* High memory window mapping attributes. */

    unsigned char  IsHWByteSwap;        /* Is the EPC capable of hardware    */
                                        /* byte swapping?                    */
                                        /*     TRUE                          */
                                        /*     FALSE                         */
    unsigned short AddressMod;          /* Valid address modifiers (OR'd     */
                                        /* combination of):                  */
                                        /*     EPC_A16S                      */
                                        /*     EPC_A24SD                     */
                                        /*     EPC_A32SD                     */
    unsigned short ByteOrdering;        /* Valid byte ordering values (OR'd  */
                                        /* combination of):                  */
                                        /*     EPC_IBO                       */
                                        /*     EPC_MBO                       */
    unsigned short DataWidth;           /* Valid data widths (OR'd           */
                                        /* combination of):                  */
                                        /*     EPC_8_BIT                     */
                                        /*     EPC_8_BIT_ODD                 */
                                        /*     EPC_16_BIT                    */
                                        /*     EPC_32_BIT                    */
                                        /*     EPC_FASTCOPY                  */
    unsigned short MinA16Address;       /* Minimum accessible A16 address.   */
    unsigned short MaxA16Address;       /* Maximum accessible A16 address.   */
    unsigned long  MinA24Address;       /* Minimum accessible A24 address.   */
    unsigned long  MaxA24Address;       /* Maximum accessible A24 address.   */
    unsigned long  MinA32Address;       /* Minimum accessible A32 address.   */
    unsigned long  MaxA32Address;       /* Maximum accessible A32 address.   */

    /* Event attributes. */

    unsigned long  EventMask;           /* Valid events (OR'd combination    */
                                        /* of):                              */
                                        /*     EPC_MSG_INT                   */
                                        /*     EPC_VME1_INT                  */
                                        /*     ...                           */
                                        /*     EPC_VME7_INT                  */
                                        /*     EPC_SIGNAL_INT                */
                                        /*     EPC_TTL_TRIG0_INT             */
                                        /*     ...                           */
                                        /*     EPC_TTL_TRIG7_INT             */
                                        /*     EPC_ACFAIL_ERR                */
                                        /*     EPC_BERR_ERR                  */
                                        /*     EPC_SYSFAIL_ERR               */
                                        /*     EPC_WATCHDOG_ERR              */
                                        /*     EPC_SYSRESET_ERR              */

    /* EPC bus configuration attributes. */

    unsigned short BusEnable;           /* Valid bus enable attributes (OR'd */
                                        /* combination of):                  */
                                        /*     EPC_ENABLE_BUS                */
                                        /*     EPC_DISABLE_BUS               */
    unsigned short BusArbMode;          /* Valid bus arbitration mode        */
                                        /* attributes (OR'd combination of): */
                                        /*     EPC_PRIORITY                  */
                                        /*     EPC_ROUND_ROBIN               */
    unsigned short BusArbPriority;      /* Valid bus arbitration priority    */
                                        /* attributes (OR'd combination of): */
                                        /*     EPC_PRIORITY0                 */
                                        /*     EPC_PRIORITY1                 */
                                        /*     EPC_PRIORITY2                 */
                                        /*     EPC_PRIORITY3                 */
    unsigned short BusRelease;          /* Valid bus release attributes      */
                                        /* (OR'd combination of):            */
                                        /*     EPC_ROR                       */
                                        /*     EPC_RONR                      */

    /* EPC miscellaneous configuration attributes. */

    unsigned char  IsBERRAssertion;     /* Is software capable of asserting  */
                                        /* the sticky BERR bit?              */
                                        /*     TRUE                          */
                                        /*     FALSE                         */
    unsigned long  GetMiscMask;         /* Miscellaneous attributes that can */
                                        /* be queried (OR'd combination of): */
                                        /*     EPC_DIR                       */
                                        /*     EPC_DOR                       */
                                        /*     EPC_ERR                       */
                                        /*     EPC_PASS                      */
                                        /*     EPC_PIPELINE_BUSY             */
                                        /*     EPC_READY                     */
                                        /*     EPC_RRDY                      */
                                        /*     EPC_RSRC_MGR                  */
                                        /*     EPC_STICKY_BERR               */
                                        /*     EPC_SYSFAIL_OUT               */
                                        /*     EPC_SYSRESET_IN               */
                                        /*     EPC_TTL_LATCH0                */
                                        /*     ...                           */
                                        /*     EPC_TTL_LATCH7                */
                                        /*     EPC_WATCHDOG                  */
                                        /*     EPC_WRDY                      */
    unsigned long  SetMiscMask;         /* Miscellaneous attributes that can */
                                        /* be defined (OR'd combination of): */
                                        /*     EPC_DIR                       */
                                        /*     EPC_DOR                       */
                                        /*     EPC_ERR                       */
                                        /*     EPC_PASS                      */
                                        /*     EPC_READY                     */
                                        /*     EPC_RESET                     */
                                        /*     EPC_RRDY                      */
                                        /*     EPC_RSRC_MGR                  */
                                        /*     EPC_STICKY_BERR               */
                                        /*     EPC_SYSFAIL_OUT               */
                                        /*     EPC_SYSRESET_IN               */
                                        /*     EPC_WRDY                      */

    /* EPC slave memory configuration attributes. */

    unsigned char  IsSelfAccess;        /* Is the EPC capable of slave       */
                                        /* memory self-accesses?             */
                                        /*     TRUE                          */
                                        /*     FALSE                         */
    unsigned short SlaveSpace;          /* Valid slave memory address spaces */
                                        /* (OR'd combination of):            */
                                        /*     EPC_DISABLED                  */
                                        /*     EPC_A24                       */
                                        /*     EPC_A32                       */
    unsigned short SlaveWidth;          /* Valid slave memory access widths  */
                                        /* (OR'd combination of):            */
                                        /*     EPC_8_BIT                     */
                                        /*     EPC_16_BIT                    */
                                        /*     EPC_32_BIT                    */
    unsigned long  MinA24Slave;         /* Minimum A24 slave memory base     */
                                        /* address.                          */
    unsigned long  MaxA24Slave;         /* Maximum A24 slave memory base     */
                                        /* address.                          */
    unsigned long  A24SlaveBaseInc;     /* A24 slave memory base increment.  */
    unsigned long  MinA32Slave;         /* Minimum A32 slave memory base     */
                                        /* address.                          */
    unsigned long  MaxA32Slave;         /* Maximum A32 slave memory base     */
                                        /* address.                          */
    unsigned long  A32SlaveBaseInc;     /* A32 slave memory base increment.  */

    /* EPC unique logical address configuration attributes. */

    unsigned char  MinULA;              /* Minimum valid ULA.                */
    unsigned char  MaxULA;              /* Maximum valid ULA.                */

    /* Bus line attributes. */

    unsigned long  GetBusLineMask;      /* Bus control lines that can be     */
                                        /* queried (OR'd combination of):    */
                                        /*     EPC_ACFAIL                    */
                                        /*     EPC_SYSFAIL                   */
                                        /*     EPC_SYSRESET                  */
    unsigned long  GetBusMODIDMask;     /* Bus MODID lines that can be       */
                                        /* queried (OR'd combination of):    */
                                        /*     EPC_SLOT_MODID                */
                                        /*     EPC_MODID0                    */
                                        /*     ...                           */
                                        /*     EPC_MODID12                   */
    unsigned long  GetBusTriggerMask;   /* Bus trigger lines that can be     */
                                        /* queried (OR'd combination of):    */
                                        /*     EPC_ECL_TRIG0                 */
                                        /*     EPC_ECL_TRIG1                 */
                                        /*     EPC_TTL_TRIG0                 */
                                        /*     ...                           */
                                        /*     EPC_TTL_TRIG7                 */

    /* EPC line attributes. */

    unsigned long  GetEpcLineMask;      /* EPC control lines that can be     */
                                        /* queried (OR'd combination of):    */
                                        /*     EPC_SYSFAIL                   */
                                        /*     EPC_SYSRESET                  */
    unsigned long  SetEpcLineMask;      /* EPC control lines that can be     */
                                        /* defined (OR'd combination of):    */
                                        /*     EPC_SYSFAIL                   */
                                        /*     EPC_SYSRESET                  */
    unsigned long  GetEpcMODIDMask;     /* EPC MODID lines that can be       */
                                        /* queried (OR'd combination of):    */
                                        /*     EPC_MODID0                    */
                                        /*     ...                           */
                                        /*     EPC_MODID12                   */
    unsigned long  SetEpcMODIDMask;     /* EPC MODID lines that can be       */
                                        /* defined (OR'd combination of):    */
                                        /*     EPC_MODID0                    */
                                        /*     ...                           */
                                        /*     EPC_MODID12                   */
    unsigned long  GetEpcTriggerMask;   /* EPC trigger lines that can be     */
                                        /* queried (OR'd combination of):    */
                                        /*     EPC_ECL_TRIG0                 */
                                        /*     EPC_ECL_TRIG1                 */
                                        /*     EPC_TTL_TRIG0                 */
                                        /*     ...                           */
                                        /*     EPC_TTL_TRIG7                 */
    unsigned long  SetEpcTriggerMask;   /* EPC trigger lines that can be     */
                                        /* queried (OR'd combination of):    */
                                        /*     EPC_ECL_TRIG0                 */
                                        /*     EPC_ECL_TRIG1                 */
                                        /*     EPC_TTL_TRIG0                 */
                                        /*     ...                           */
                                        /*     EPC_TTL_TRIG7                 */
    unsigned long  InTriggerMask;       /* EPC trigger lines that can be     */
                                        /* used as input triggers for the    */
                                        /* trigger mapping operation (OR'd   */
                                        /* combination of):                  */
                                        /*     EPC_EXT_TRIG0                 */
                                        /*     EPC_TTL_TRIG0                 */
                                        /*     ...                           */
                                        /*     EPC_TTL_TRIG7                 */
    unsigned long  OutTriggerMask[EPC_TRIGGER_CNT];
                                        /* EPC trigger lines that can be     */
                                        /* used as output triggers in a      */
                                        /* trigger mapping operation (one    */
                                        /* array element for each potential  */
                                        /* input trigger; each entry is an   */
                                        /* OR'd combination of):             */
                                        /*     EPC_EXT_TRIG0                 */
                                        /*     EPC_TTL_TRIG0                 */
                                        /*     ...                           */
                                        /*     EPC_TTL_TRIG7                 */

    /* Watchdog timer attributes. */

    unsigned short WatchdogCfg;         /* Valid watchdog timer configura-   */
                                        /* tions (OR'd combination of):      */
                                        /*     EPC_WDT_RESET                 */
                                        /*     EPC_WDT_FAST_ERROR            */
                                        /*     EPC_WDT_FAST_RESET            */
                                        /*     EPC_WDT_SLOW_ERROR            */
                                        /*     EPC_WDT_SLOW_RESET            */

    /* Servant attributes. */

    unsigned char  IsProtocolError;     /* Is the EPC capable of signalling  */
                                        /* a protocol error to its commander?*/
                                        /*     TRUE                          */
                                        /*     FALSE                         */
    unsigned short WSSize;              /* Valid word serial command and     */
                                        /* response sizes (OR'd combination  */
                                        /* of):                              */
                                        /*     EPC_16_BIT                    */
                                        /*     EPC_32_BIT                    */
                                        /*     EPC_48_BIT                    */
    unsigned short EnableNextCommand;   /* Valid word serial command enable  */
                                        /* constants (OR'd combination of):  */
                                        /*     EPC_DISABLE_ALL               */
                                        /*     EPC_ENABLE_WRDY               */
                                        /*     EPC_ENABLE_DIR                */
                                        /*     EPC_ENABLE_DOR                */
                                        /*     EPC_ENABLE_ALL                */
    unsigned long  MethodMask;          /* Valid methods for sending         */
                                        /* protocol events (OR'd combination */
                                        /* of):                              */
                                        /*     EPC_VME1_INT                  */
                                        /*     ...                           */
                                        /*     EPC_VME7_INT                  */
                                        /*     EPC_SIGNAL_REG                */

    unsigned long  Reserved[16];        /* Reserved area (future expansion). */
};

#ifndef LynxOS
#pragma pack()
#endif /* not LynxOS */

/*
 * FUNCTION PROTOTYPES...
 */

#ifdef NO_PROTOTYPES

extern short FAR PASCAL EpcAssertInterrupt();
extern short FAR PASCAL EpcCloseSession();
extern short FAR PASCAL EpcCmdReceiveWSBuffer();
extern short FAR PASCAL EpcCmdSendWSBuffer();
extern short FAR PASCAL EpcCmdSendWSCommand();
extern short FAR PASCAL EpcCopyData();
extern short FAR PASCAL EpcDeassertInterrupt();
extern short FAR PASCAL EpcGetBusAttributes();
extern short FAR PASCAL EpcGetBusInterrupts();
extern short FAR PASCAL EpcGetBusLines();
#ifdef VXI
extern short FAR PASCAL EpcGetBusMODID();
extern short FAR PASCAL EpcGetBusTriggers();
#endif /* VXI */
extern short FAR PASCAL EpcGetEpcInterrupt();
extern short FAR PASCAL EpcGetEpcLines();
#ifdef VXI
extern short FAR PASCAL EpcGetEpcMODID();
extern short FAR PASCAL EpcGetEpcTriggers();
extern short FAR PASCAL EpcGetEpcTriggerMapping();
#endif /* VXI */
extern short FAR PASCAL EpcGetErrorString();
extern short FAR PASCAL EpcGetEventEnableMask();
extern short FAR PASCAL EpcGetEventHandler();
extern short FAR PASCAL EpcGetLockingTimeout();
extern short FAR PASCAL EpcGetMappingAttributes();
extern short FAR PASCAL EpcGetMiscAttributes();
extern short FAR PASCAL EpcGetSessionData();
extern short FAR PASCAL EpcGetSlaveMapping();
extern short FAR PASCAL EpcGetULA();
extern short FAR PASCAL EpcLockSession();
extern short FAR PASCAL EpcMapBusMemory();
#ifdef VXI
extern short FAR PASCAL EpcMapEpcTriggers();
#endif /* VXI */
extern short FAR PASCAL EpcMapSharedMemory();
extern short FAR PASCAL EpcOpenSession();
extern short FAR PASCAL EpcPulseEpcLines();
#ifdef VXI
extern short FAR PASCAL EpcPulseEpcTriggers();
#endif /* VXI */
extern short FAR PASCAL EpcSetBusAttributes();
extern short FAR PASCAL EpcSetEpcLines();
#ifdef VXI
extern short FAR PASCAL EpcSetEpcMODID();
extern short FAR PASCAL EpcSetEpcTriggers();
#endif /* VXI */
extern short FAR PASCAL EpcSetEventEnableMask();
extern short FAR PASCAL EpcSetEventHandler();
extern short FAR PASCAL EpcSetLockingTimeout();
extern short FAR PASCAL EpcSetMiscAttributes();
extern short FAR PASCAL EpcSetSessionData();
extern short FAR PASCAL EpcSetSlaveMapping();
extern short FAR PASCAL EpcSetULA();
extern short FAR PASCAL EpcSrvEnableWSCommand();
extern short FAR PASCAL EpcSrvReceiveWSCommand();
extern short FAR PASCAL EpcSrvSendProtocolEvent();
extern short FAR PASCAL EpcSrvSendWSProtocolError();
extern short FAR PASCAL EpcSrvSendWSResponse();
extern short FAR PASCAL EpcSwap16();
extern short FAR PASCAL EpcSwap32();
extern short FAR PASCAL EpcSwap48();
extern short FAR PASCAL EpcSwap64();
extern short FAR PASCAL EpcSwap80();
extern short FAR PASCAL EpcSwapBuffer();
extern short FAR PASCAL EpcUnlockSession();
extern short FAR PASCAL EpcUnmapBusMemory();
extern short FAR PASCAL EpcUnmapSharedMemory();
extern short FAR PASCAL EpcVerifyEnvironment();
extern short FAR PASCAL EpcWaitForEvent();
extern short FAR PASCAL EpcWatchdogTimer();

#else /* not NO_PROTOTYPES */

short FAR PASCAL
EpcAssertInterrupt(unsigned long Session_ID,
                   unsigned long Event_Mask);

short FAR PASCAL
EpcCloseSession(unsigned long Session_ID);

short FAR PASCAL
EpcCmdReceiveWSBuffer(unsigned long      Session_ID,
                      unsigned short     ULA,
                      unsigned char FAR *Buffer_Ptr,
                      unsigned long      Buffer_Size,
                      short              Term_Character,
                      unsigned long      Timeout,
                      unsigned long FAR *Term_Reason_Ptr,
                      unsigned long FAR *Receive_Size_Ptr);

short FAR PASCAL
EpcCmdSendWSBuffer(unsigned long      Session_ID,
                   unsigned short     ULA,
                   unsigned char FAR *Buffer_Ptr,
                   unsigned long      Buffer_Size,
                   unsigned short     EOI_Flag,
                   unsigned long      Timeout,
                   unsigned long FAR *Send_Size_Ptr);

short FAR PASCAL
EpcCmdSendWSCommand(unsigned long  Session_ID,
                    unsigned short ULA,
                    void      FAR *Command_Ptr,
                    void      FAR *Response_Ptr,
                    unsigned short Size,
                    unsigned long  Timeout);

short FAR PASCAL
EpcCopyData(unsigned long      Session_ID,
            void         HUGE *Source_Ptr,
            void         HUGE *Dest_Ptr,
            unsigned long      Copy_Size,
            unsigned short     Width,
            unsigned long FAR *Actual_Size_Ptr);

short FAR PASCAL
EpcDeassertInterrupt(unsigned long Session_ID);

short FAR PASCAL
EpcGetBusAttributes(unsigned long       Session_ID,
                    unsigned short FAR *Bus_Enable_Ptr,
                    unsigned short FAR *Bus_Arb_Mode_Ptr,
                    unsigned short FAR *Bus_Arb_Priority_Ptr,
                    unsigned short FAR *Bus_Release_Ptr);

short FAR PASCAL
EpcGetBusInterrupts(unsigned long      Session_ID,
                    unsigned long FAR *Event_Mask_Ptr);

short FAR PASCAL
EpcGetBusLines(unsigned long      Session_ID,
               unsigned long FAR *Line_Mask_Ptr);

#ifdef VXI
short FAR PASCAL
EpcGetBusMODID(unsigned long      Session_ID,
               unsigned long FAR *MODID_Mask_Ptr);
#endif /* VXI */

#ifdef VXI
short FAR PASCAL
EpcGetBusTriggers(unsigned long      Session_ID,
                  unsigned long FAR *Trigger_Mask_Ptr);
#endif /* VXI */

short FAR PASCAL
EpcGetEpcInterrupt(unsigned long      Session_ID,
                   unsigned long FAR *Event_Mask_Ptr);

short FAR PASCAL
EpcGetEpcLines(unsigned long      Session_ID,
               unsigned long FAR *Line_Mask_Ptr);

#ifdef VXI
short FAR PASCAL
EpcGetEpcMODID(unsigned long      Session_ID,
               unsigned long FAR *MODID_Mask_Ptr);
#endif /* VXI */

#ifdef VXI
short FAR PASCAL
EpcGetEpcTriggers(unsigned long      Session_ID,
                  unsigned long FAR *Trigger_Mask_Ptr);
#endif /* VXI */

#ifdef VXI
short FAR PASCAL
EpcGetEpcTriggerMapping(unsigned long      Session_ID,
                        unsigned long      In_Trigger_Mask,
                        unsigned long FAR *Out_Trigger_Mask_Ptr);
#endif /* VXI */

short FAR PASCAL
EpcGetErrorString(short Return_Value, char FAR *Buffer_Ptr);

short FAR PASCAL
EpcGetEventEnableMask(unsigned long      Session_ID,
                      unsigned long FAR *Event_Mask_Ptr);

short FAR PASCAL
EpcGetEventHandler(unsigned long    Session_ID,
                   unsigned long    Event_Mask,
                   void (FAR * FAR *Event_Handler_Ptr)(unsigned long,
                                                       unsigned long,
                                                       unsigned long),
                   void  FAR * FAR *Stack_Ptr_Ptr);

short FAR PASCAL
EpcGetLockingTimeout(unsigned long      Session_ID,
                     unsigned long FAR *Timeout_Ptr);

short FAR PASCAL
EpcGetMappingAttributes(unsigned long       Session_ID,
                        volatile void HUGE *Mapped_Ptr,
                        unsigned short FAR *Address_Mod_Ptr,
                        unsigned short FAR *Byte_Ordering_Ptr,
                        unsigned long  FAR *Base_Address_Ptr,
                        unsigned long  FAR *Size_Ptr);

short FAR PASCAL
EpcGetMiscAttributes(unsigned long      Session_ID,
                     unsigned long FAR *Misc_Mask_Ptr);

short FAR PASCAL
EpcGetSessionData(unsigned long      Session_ID,
                  unsigned long FAR *Session_Data_Ptr);

short FAR PASCAL
EpcGetSlaveMapping(unsigned long       Session_ID,
                   unsigned short FAR *Address_Space_Ptr,
                   unsigned long  FAR *Base_Address_Ptr);

short FAR PASCAL
EpcGetULA(unsigned long       Session_ID,
          unsigned short FAR *ULA_Ptr);

short FAR PASCAL
EpcLockSession(unsigned long Session_ID);

short FAR PASCAL
EpcMapBusMemory(unsigned long             Session_ID,
                unsigned short            Address_Mod,
                unsigned short            Byte_Ordering,
                unsigned long             Base_Address,
                unsigned long             Size,
                volatile void HUGE * FAR *Mapped_Ptr_Ptr);

#ifdef VXI
short FAR PASCAL
EpcMapEpcTriggers(unsigned long Session_ID,
                  unsigned long In_Trigger_Mask,
                  unsigned long Out_Trigger_Mask);
#endif /* VXI */

short FAR PASCAL
EpcMapSharedMemory(unsigned long             Session_ID,
                   unsigned long        FAR *Base_Address_Ptr,
                   unsigned long        FAR *Size_Ptr,
                   volatile void HUGE * FAR *Mapped_Ptr_Ptr);

short FAR PASCAL
EpcOpenSession(unsigned long FAR *Session_ID_Ptr);

short FAR PASCAL
EpcPulseEpcLines(unsigned long Session_ID,
                 unsigned long Line_Mask);

#ifdef VXI
short FAR PASCAL
EpcPulseEpcTriggers(unsigned long Session_ID,
                    unsigned long Trigger_Mask);
#endif /* VXI */

short FAR PASCAL
EpcSetBusAttributes(unsigned long  Session_ID,
                    unsigned short Bus_Enable,
                    unsigned short Bus_Arb_Mode,
                    unsigned short Bus_Arb_Priority,
                    unsigned short Bus_Release);

short FAR PASCAL
EpcSetEpcLines(unsigned long Session_ID,
               unsigned long Line_Mask);

#ifdef VXI
short FAR PASCAL
EpcSetEpcMODID(unsigned long Session_ID,
               unsigned long MODID_Mask);
#endif /* VXI */

#ifdef VXI
short FAR PASCAL
EpcSetEpcTriggers(unsigned long Session_ID,
                  unsigned long Trigger_Mask);
#endif /* VXI */

short FAR PASCAL
EpcSetEventEnableMask(unsigned long Session_ID,
                      unsigned long Event_Mask);

short FAR PASCAL
EpcSetEventHandler(unsigned long Session_ID,
                   unsigned long Event_Mask,
                   void    (FAR *Event_Handler)(unsigned long,
                                                unsigned long,
                                                unsigned long),
                   void     FAR *Stack_Ptr);

short FAR PASCAL
EpcSetLockingTimeout(unsigned long Session_ID,
                     unsigned long Timeout);

short FAR PASCAL
EpcSetMiscAttributes(unsigned long Session_ID,
                     unsigned long Misc_Mask);

short FAR PASCAL
EpcSetSessionData(unsigned long Session_ID,
                  unsigned long Session_Data);

short FAR PASCAL
EpcSetSlaveMapping(unsigned long  Session_ID,
                   unsigned short Address_Space,
                   unsigned long  Base_Address);

short FAR PASCAL
EpcSetULA(unsigned long  Session_ID,
          unsigned short ULA);

short FAR PASCAL
EpcSrvEnableWSCommand(unsigned long  Session_ID,
                      unsigned short Enable_Next_Command);

short FAR PASCAL
EpcSrvReceiveWSCommand(unsigned long       Session_ID,
                       void           FAR *Command_Ptr,
                       unsigned short FAR *Command_Size_Ptr,
                       unsigned short      Enable_Next_Command,
                       unsigned long       Timeout);

short FAR PASCAL
EpcSrvSendProtocolEvent(unsigned long  Session_ID,
                        unsigned short ULA,
                        unsigned long  Method_Mask,
                        unsigned short Protocol_Event);

short FAR PASCAL
EpcSrvSendWSProtocolError(unsigned long  Session_ID,
                          unsigned short Protocol_Error,
                          unsigned short Enable_Next_Command,
                          unsigned long  Timeout);

short FAR PASCAL
EpcSrvSendWSResponse(unsigned long  Session_ID,
                     void      FAR *Response_Ptr,
                     unsigned short Response_Size,
                     unsigned short Enable_Next_Command,
                     unsigned long  Timeout);

short FAR PASCAL
EpcSwapBuffer(void      FAR *Buffer_Ptr,
              unsigned long  Buffer_Size,
              unsigned short Width);

short FAR PASCAL
EpcSwap16(unsigned short FAR *Value_Ptr);

short FAR PASCAL
EpcSwap32(unsigned long FAR *Value_Ptr);

short FAR PASCAL
EpcSwap48(void FAR *Value_Ptr);

short FAR PASCAL
EpcSwap64(void FAR *Value_Ptr);

short FAR PASCAL
EpcSwap80(void FAR *Value_Ptr);

short FAR PASCAL
EpcUnlockSession(unsigned long Session_ID);

short FAR PASCAL
EpcUnmapBusMemory(unsigned long       Session_ID,
                  volatile void HUGE *Mapped_Ptr);

short FAR PASCAL
EpcUnmapSharedMemory(unsigned long       Session_ID,
                     volatile void HUGE *Mapped_Ptr);

short FAR PASCAL
EpcVerifyEnvironment(struct EpcEnvironment FAR *Environment_Ptr);

short FAR PASCAL
EpcWaitForEvent(unsigned long      Session_ID,
                unsigned long      Timeout,
                unsigned long      Wait_Mask,
                unsigned long FAR *Event_Mask_Ptr,
                unsigned long FAR *Event_Data_Ptr);

short FAR PASCAL
EpcWatchdogTimer(unsigned long  Session_ID,
                 unsigned short Watchdog_Cfg);

#endif /* not NO_PROTOTYPES */
#if (defined(__TCPLUSPLUS__) || defined(__BCPLUSPLUS__) || defined(__cplusplus))
}  /* special bracket for C++ */
#endif /* __TCPLUSPLUS__ or __BCPLUSPLUS__ or __cplusplus */
#endif /* _FENCE_BUSMGR_H_ */
/*$MK-SKIP*/
