
#define ulong  unsigned long
#define dword  unsigned long
#define ushort unsigned short
#define word   unsigned int
#define byte   unsigned char

#define A16 0
#define A24 1
#define A32 2
#define D16 3
#define D32 4
#define BUS_ERROR 1


#define HORIZONTAL   2
#define VERTICAL     1
#include <conio.h>
#define BERR 0x1
#define NO_BUS_ERR 0x0
#define NO_MATCH                    0x0
#define EXACT_MATCH                 0x1
#define MATCH_WITH_ADDED_EXTENSION  0x2
#define CLR_KB    while(kbhit()) getch();

void clrkb (void);   // Uses The While kbhit loop to Clear The Keyboard Buffer.
void CreatePattern(unsigned long far *DestBlk, unsigned long NumOfLongWrds,unsigned int Pattern);
void CreatePattern(unsigned int far *DestBlk, unsigned int NumOfWrds,int Pattern);
void CreatePattern(unsigned char far *DestBlk, unsigned int NumOfBytes,int Pattern);
void ViewBuffer(unsigned long far *Source, unsigned int NumOfLongWrds,int ViewMethod,
                int UprLtX,int UprLtY);
void ViewBuffer(unsigned char far *Source, unsigned int NumOfBytes,int ViewMethod,
                int UprLtX,int UprLtY);
void ViewBuffer(unsigned int far *Source, unsigned int NumOfWrds,int ViewMethod,
                int UprLtX,int UprLtY);
void LogScreen(int first_line, int last_line, FILE *logF);
void donothing(void);
int GetsWithDefault(char DefaultStr[],char *ReturnStr);
int GetsWithDefault(char DefaultStr,char *ReturnStr);
unsigned long CompareBuffers(unsigned int far *TxMittedBlk, unsigned int far *RcvdBlk,
                             unsigned int NumberOfWords);
void SignalIndicator(int CurX=0,int CurY=0,char Char0='\\',char Char1='|',
                     char Char2='/',char Char3='-',int IndicatorChoice=0);
void setcursor(int CursurValue); // Following Defines are for the Procedure
#define NORMAL     0x00
#define INVISIBLE  0x20

// The Following Comment applies to the
//    Following Three procedures/Classes/Structs:
//             struct -> unsigned long Screen.HotKeyValue;
//             class Procedure -> unsigned long MenuList::PromptUsr(void)
//             Single Procedure -> unsigned long PromptUsr(void)
//
//       COMMENT TO REMEMBER  7214361  // VERY IMPORTANT
// Definition of the Returned Value (32 bits)
// The Lower 12 bits (0..11) are for the ascii code returned for the pressed key
//            3 bits (12..14) are reserved for Future expansion of routine
//            1 bit  (15)  signal Extended Key. '1' says key is Extended
//
//           bit 16 Right  Shift Pressed
//           bit 17 Left   Shift Pressed
//           bit 18 Ctrl         Pressed
//           bit 19 Alt          Pressed
//           bit 20 Scroll Lock  Enabled
//           bit 21 Num    Lock  Enabled
//           bit 22 Caps   Lock  Enabled
//           bit 23 Insert Key   Toggled
//           bit 24 SysReq key   Pressed
//           bit 25 Caps   Lock  pressed
//           bit 26 Num    Lock  Pressed
//           bit 27 Scroll lock  Pressed
//           bit 28 Right  Alt   Pressed
//           bit 29 Right  Ctrl  Pressed
//           bit 30 Left   Alt   Pressed
//           bit 31 Left   Ctrl  Pressed
//
//  The following Defines are use to apply the method

#define MENU_BACKSPACE              0x00000008
#define MENU_TAB                    0x00000009
#define MENU_Enter                  0x0000000D
#define MENU_esc                    0x0000001B
#define MENU_Space                  0x00000020
#define MENU_APOSTROPHE             0x00000027
#define MENU_COMMA                  0x0000002C
#define MENU_MINUS                  0x0000002D
#define MENU_PERIOD                 0x0000002E
#define MENU_FWD_SLASH              0x0000002F
#define MENU_0                      0x00000030
#define MENU_1                      0x00000031
#define MENU_2                      0x00000032
#define MENU_3                      0x00000033
#define MENU_4                      0x00000034
#define MENU_5                      0x00000035
#define MENU_6                      0x00000036
#define MENU_7                      0x00000037
#define MENU_8                      0x00000038
#define MENU_9                      0x00000039
#define MENU_SEMI_COLON             0x0000003B
#define MENU_EQUALS                 0x0000003D
#define MENU_OPEN_SQ_BRACKET        0x0000005B
#define MENU_BKW_SLASH              0x0000005C
#define MENU_CLOSE_SQ_BRACKET       0x0000005D
#define MENU_OPEN_SINGLE_QUOTE      0x00000060
#define MENU_a                      0x00000061
#define MENU_b                      0x00000062
#define MENU_c                      0x00000063
#define MENU_d                      0x00000064
#define MENU_e                      0x00000065
#define MENU_f                      0x00000066
#define MENU_g                      0x00000067
#define MENU_h                      0x00000068
#define MENU_i                      0x00000069
#define MENU_j                      0x0000006A
#define MENU_k                      0x0000006B
#define MENU_l                      0x0000006C
#define MENU_m                      0x0000006D
#define MENU_n                      0x0000006E
#define MENU_o                      0x0000006F
#define MENU_p                      0x00000070
#define MENU_q                      0x00000071
#define MENU_r                      0x00000072
#define MENU_s                      0x00000073
#define MENU_t                      0x00000074
#define MENU_u                      0x00000075
#define MENU_v                      0x00000076
#define MENU_w                      0x00000077
#define MENU_x                      0x00000078
#define MENU_y                      0x00000079
#define MENU_z                      0x0000007A
#define MENU_f1                     0x0000103B
#define MENU_f2                     0x0000103C
#define MENU_f3                     0x0000103D
#define MENU_f4                     0x0000103E
#define MENU_f5                     0x0000103F
#define MENU_f6                     0x00001040
#define MENU_f7                     0x00001041
#define MENU_f8                     0x00001042
#define MENU_f9                     0x00001043
#define MENU_f10                    0x00001044
#define MENU_f11                    0x00001085
#define MENU_f12                    0x00001086

struct Screen
{ char HotKeyName[50];
  unsigned long HotKeyValue;
  void (*action)();
  char *Line;
}; //struct Screen

class MenuList
{ public:
      MenuList(Screen *HotKeyValuesProceduresMenu);
      void Display(int UprLtX=1, int UprLtY=1, int Verically=1);
      void Active(int Beg,int End);
      unsigned long PromptUsr(unsigned long Mask = 0x0000FFFF);

   private:
      Screen *mMenu;
      int mBegActive,mEndActive,mLineCnt;
}; // class MenuList

// Separate Routine from class; however, it performs the same Except for Mask
//   Mask does modify the return value within this procedure.
unsigned long PromptUsr(unsigned long Mask = 0x0000FFFF);

int VerifyFileExists(char Filename[],char Extension[]="");

